package com.test;

import org.drools.process.instance.WorkItemHandler;
import org.drools.runtime.process.WorkItem;
import org.drools.runtime.process.WorkItemManager;
import org.drools.runtime.process.ProcessInstance;
import org.drools.runtime.process.NodeInstance;
import org.drools.runtime.rule.FactHandle;
import org.drools.runtime.ObjectFilter;
import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.workflow.instance.node.WorkItemNodeInstance;
import org.drools.workflow.instance.impl.WorkflowProcessInstanceImpl;

import java.util.Collection;
import java.util.Iterator;

/**
 * Created by IntelliJ IDEA.
 * User: gaia
 * Date: 29-Oct-2009
 * Time: 16:47:42
 * To change this template use File | Settings | File Templates.
 */
public class StatusChangeWorkItemHandler implements WorkItemHandler {

    private StatefulKnowledgeSession ksession;
    private int count = 0;

    public StatusChangeWorkItemHandler(StatefulKnowledgeSession ksession) {
        this.ksession = ksession;
    }

    public void executeWorkItem(WorkItem workItem, WorkItemManager workItemManager) {

        System.out.println(String.format("Executing work item: %s", workItem.toString()));
        System.out.println(String.format("Node ID: %d", getCurrentNodeId(workItem)));

        Collection<FactHandle> factHandles = ksession.getFactHandles(new ObjectFilter() {
            public boolean accept(Object object) {
                return (object instanceof SimpleFact);
            }
        });
        for (Iterator<FactHandle> iterator = factHandles.iterator(); iterator.hasNext(); ) {
            FactHandle factHandle = iterator.next();
            SimpleFact fact = (SimpleFact) ksession.getObject(factHandle);
            fact.setStatus((count % 2 == 0) ? "Error" : "Success");
            count++;
            ksession.update(factHandle, fact);
        }

        workItemManager.completeWorkItem(workItem.getId(), null);
    }

    public void abortWorkItem(WorkItem workItem, WorkItemManager workItemManager) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    private long getCurrentNodeId(WorkItem workItem) {
        ProcessInstance processInstance = ksession.getProcessInstance(workItem.getProcessInstanceId());
        if (processInstance instanceof WorkflowProcessInstanceImpl) {
            Collection<NodeInstance> nodeInstances = ((WorkflowProcessInstanceImpl) processInstance).getNodeInstances();
            for (NodeInstance nodeInstance : nodeInstances) {
                System.out.println(String.format("Node instance: %s", nodeInstance));
                if (nodeInstance instanceof WorkItemNodeInstance) {
                    WorkItemNodeInstance workItemNodeInstance = (WorkItemNodeInstance) nodeInstance;
                    if (workItemNodeInstance.getWorkItem() == workItem) {
                        return workItemNodeInstance.getNodeId();
                    }
                }
            }
        }
        throw new RuntimeException(String.format("Error determining node ID for work item: %s", workItem.toString()));
    }
}
